
using System;
using System.Data.SQLite;

namespace Dizzy
{


	public class GlobalConfig
	{
		public string password;
		public bool authenticated = false;
		private SQLiteConnection conn;
		
		public GlobalConfig ()
		{
			conn = new SQLiteConnection ("Data Source=" + DataBaseName () + ";Version=3;");
			// Controlliamo che il database sia correttamente
			// inizializzato. 
			Init ();
		}
		
		public string GetValue(string field)
		{
			lock (this) {
				string val;
				
				SQLiteCommand sqlCmd;
				this.conn.Open ();
				sqlCmd = this.conn.CreateCommand ();
				
				sqlCmd.CommandText = "SELECT value FROM config WHERE field = '" + field + "';";
				SQLiteDataReader reader = sqlCmd.ExecuteReader ();
				if (reader.Read())
					val = reader.GetString(0);
				else
					val  = "";
				this.conn.Close ();
				return val;
			}
		}
		
		public void InsertValue(string field, string val)
		{
			lock (this)
			{
			
				SQLiteCommand sqlCmd;
			
				this.conn.Open ();
				sqlCmd = this.conn.CreateCommand ();
			
				sqlCmd.CommandText = "INSERT OR REPLACE INTO config VALUES ('" + field + "', '" + val + "');";
				sqlCmd.ExecuteNonQuery ();
				this.conn.Close ();
			}
		}
		
		protected void Init ()
		{

			SQLiteCommand sqlCmd;
			this.conn.Open ();
			sqlCmd = this.conn.CreateCommand ();
			
			sqlCmd.CommandText = "SELECT * FROM sqlite_master WHERE type='table';";
			SQLiteDataReader reader = sqlCmd.ExecuteReader ();
			
			if(!reader.HasRows)
			{
				this.conn.Close ();
				InitialSetup ();
			}
			else 
				this.conn.Close ();

	}
		
		protected void InitialSetup ()
		{
			lock (this)
			{
				// Dobbiamo creare la struttura del database
				SQLiteCommand sqlCmd;
				this.conn.Open ();
				
				// Tabelle delle configurazioni
				sqlCmd = this.conn.CreateCommand ();
				sqlCmd.CommandText = "CREATE TABLE config (field TEXT PRIMARY KEY, value TEXT);";
				sqlCmd.ExecuteNonQuery ();
				
				// Tabella della lista
				sqlCmd = this.conn.CreateCommand ();
				sqlCmd.CommandText = "CREATE TABLE list (path TEXT PRIMARY KEY, user TEXT);";
				sqlCmd.ExecuteNonQuery ();
				
				this.conn.Close ();
			}
		}
		
		public string ConfigDir ()
		{
			string dir = "";
			if (System.Environment.OSVersion.ToString ().Contains("Windows"))
			{
				
				System.Reflection.Assembly a = System.Reflection.Assembly.GetEntryAssembly ();
				dir = System.IO.Path.GetDirectoryName (a.Location);
				
			}
			else // Assumiamo qualcosa di Unix-like
			{
				dir = System.Environment.GetEnvironmentVariable("HOME");
				dir += System.IO.Path.DirectorySeparatorChar + ".dizzy";
			}
			if (!System.IO.Directory.Exists(dir))
				System.IO.Directory.CreateDirectory (dir);
			return dir;
		}
		
		public string ListFileName () 
		{ 
			return this.ConfigDir () + System.IO.Path.DirectorySeparatorChar + "index.db";
		}
		
		protected string DataBaseName ()
		{	
			string db = this.ConfigDir () + System.IO.Path.DirectorySeparatorChar + "config.sqlite";
			if (!System.IO.File.Exists (db))
				System.IO.File.Create (db);
			return db;
		}
	}
	
}
